#ifndef _DETECTOR_H_
#define _DETECTOR_H_

#include "Point.h"
#include "Image.h"
#include "Rectangle.h"


class Detector {

public:
  //Detector();
  //~Detector();

  virtual Point apply(const Image* source, const Rectangle) = 0;

  // DetectorXYZ(Rectangle, unsigned int threshold = 0);
  void setRectangle(const Rectangle);
  Rectangle getRectangle() const;
  void setThreshold(const unsigned int);
  virtual void setIterations(const unsigned int) = 0;
  unsigned int getThreshold() const;
  // void getDetails ( &myDetailsList );

protected:  

  Rectangle myRectangle;
  unsigned int myThreshold;

  double dist(Point, double x, double y);
  double dist(Point, Point);

};

#endif  // _DETECTOR_H_
 









