#ifndef _FILTEREXPANDBLACK_H_
#define _FILTEREXPANDBLACK_H_


#include "FilterStrategy.h"
#include "Rectangle.h"


class FilterExpandBlack : public FilterStrategy {

public:

  FilterExpandBlack();
  //~FilterExpandBlack();

  Image* apply(const Image* source);

  FilterExpandBlack(unsigned int count, Rectangle rect);
  void setParameters(unsigned int count, Rectangle rect);
  void getParameters(unsigned int &count, Rectangle &rect);


private:

  unsigned int myCount;
  Rectangle myRectangle;

};

#endif // _FILTEREXPANDBLACK_H_













