#ifndef _IMAGESOURCEPPM_H_
#define _IMAGESOURCEPPM_H_

#include "Image.h"
#include "ImageSource.h"


class ImageSourcePPM : public ImageSource {

// Unerwuenschte Methoden ausschliessen
private:
  ImageSourcePPM(const ImageSourcePPM&);

public:
  ImageSourcePPM();
  // ~ImageSourcePPM();

  Image* getNextImage(int step = 1);

  // unsigned int getFirstIndex();
  // unsigned int getLastIndex();
  void setPosition(unsigned int);
  unsigned int getPosition();
  Image* getImageAbsolute(unsigned int);
  Image* getImageRelative(int = 0);
  void movePosition(int = 1);
  // unsigned int getImageHeight();
  // unsigned int getImageWidth();

  // config of the read routine
  void setParameters(char* directory, char* basename, \
                     unsigned int length, char* extension = ".ppm");
 
protected:
  //  unsigned int actualImageNumber;    // defined in abstract baseclass
  //  unsigned int firstImageNumber;
  //  unsigned int lastImageNumber;
  //  unsigned int myWidht;
  //  unsigned int myHeight;

private:
  char myDirectory[255];
  char myBasename[255];
  char myExtension[255];
  char myFilename[255];
  unsigned int myLength; 

};

#endif   // _IMAGESOURCEPPM_H_





