#ifndef _RECTANGLE_H_
#define _RECTANGLE_H_

#include "Point.h"

class Rectangle {

public:
  Rectangle();
  // ~Rectangle();
  Rectangle(unsigned int, unsigned int, unsigned int, unsigned int);
  Rectangle(const Point, const Point);
  Rectangle(const Rectangle&);
  Rectangle(const Point center, const unsigned int width, unsigned int height);
  int valid();
  Rectangle& operator=(const Rectangle&);
  int operator==(const Rectangle&);
  int getWidth() const;
  int getHeight() const;
  int getArea() const;

  int x1, y1, x2, y2;

private:
  void correctRectangle();

};

#endif // _RECTANGLE_H_
