// globale X11 Variablen
XImage *leftImage;
XImage *middleImage;
XImage *rightImage;
XImage *firstDelta;
XImage *secondDelta;
XImage *mergeDelta;

// X-Server Resources for Images
Pixmap leftPixmap = 0;
Pixmap middlePixmap = 0;
Pixmap rightPixmap = 0;
Pixmap firstPixmap = 0;
Pixmap secondPixmap = 0;
Pixmap mergePixmap = 0;

// X-Server Resources for Zooms
Pixmap zoom1Pixmap = 0;
Pixmap zoom2Pixmap = 0;


void paint();
void repaint();

//unsigned int theImageWidth;
//unsigned int theImageHeight;
//unsigned int start_frame = 20;
//unsigned int end_frame = 50;

Point lastPosition;

XImage *HistogramXImage;
Pixmap HistogramPixmap;


// Callback routines
void NextImageCallback(Widget, XtPointer, XtPointer);
void Next5ImageCallback(Widget, XtPointer, XtPointer);
void PrevImageCallback(Widget, XtPointer, XtPointer);
void Prev5ImageCallback(Widget, XtPointer, XtPointer);
void CMDscrollCallback(Widget, XtPointer, XtPointer);
void ReloadRightCallback(Widget, XtPointer, XtPointer);
void ResetCallback(Widget, XtPointer, XtPointer);
void RedrawLinesCallback(Widget, XtPointer, XtPointer);
void RedrawLinesStepCallback(Widget, XtPointer, XtPointer);
void GraphicsRepaintCallback(Widget, XtPointer, XtPointer);
void GraphicsInputEvent(Widget, XtPointer, XEvent*, Boolean*);
void GraphicsInputCallback(Widget, XtPointer, XtPointer);
void ExitCallback(Widget, XtPointer, XtPointer);
void FileSetDirCallback(Widget, XtPointer, XtPointer);
void HistogramCloseCallback(Widget, XtPointer, XtPointer);

void HistogramRepaintCallback(Widget, XtPointer, XtPointer);
void ZOOMRepaintCallback(Widget, XtPointer, XtPointer);
void ZOOMInputCallback(Widget, XtPointer, XtPointer);

void GreyscaleCallback(Widget, XtPointer, XtPointer);
void BWQdoitCallback(Widget, XtPointer, XtPointer);
void BWQdoit2Callback(Widget, XtPointer, XtPointer);
void BRIGHTdoitCallback(Widget, XtPointer, XtPointer);
void BRIGHTdoit2Callback(Widget, XtPointer, XtPointer);
void GAMMAdoitCallback(Widget, XtPointer, XtPointer);
void DELTAdoit1Callback(Widget, XtPointer, XtPointer);
void DELTAdoit2Callback(Widget, XtPointer, XtPointer);
void DELTAdoit3Callback(Widget, XtPointer, XtPointer);
void DELTAdoit4Callback(Widget, XtPointer, XtPointer);
void DELTAtestCallback(Widget, XtPointer, XtPointer);

void setStart(Widget, XtPointer, XtPointer);
void setEnd(Widget, XtPointer, XtPointer);
Point* calculateInkPositions(char*, char*, Rectangle, unsigned int, unsigned int, \
                             int, unsigned int, unsigned int);


// Helper routines
Image* DoPreprocessing(Image*);
void ChangeScrollPosition(Widget, int);


// Rubberbanding
GC xorGC;
void StartRubber(Widget, XtPointer, XtPointer);
void Rubberband(Widget, XtPointer, XEvent*, Boolean*);
void EndRubber(Widget, XtPointer, XtPointer);





