// matrix
#ifndef matrix_t
#define matrix_t

#include<vector.h>
#include<iostream.h>

/* Matrix als Vektor von Vektoren*/

template<class T>
class Matrix : public vector<vector<T> >
{
   protected:
     size_type zeilen,
               spalten;
   public:
     Matrix(size_type x = 0, size_type y = 0)
     : vector<vector<T> >(x,
             vector<T>(y)), zeilen(x), spalten(y)
     {}
     size_type Zeilen() const {return zeilen; }
     size_type Spalten() const {return spalten; }
     void init(const T& Wert)
     {
        for (size_type i = 0; i < zeilen; i++)
           for (size_type j = 0; j < spalten ; j++)
               operator[](i)[j] = Wert;
     }
     // Einheitsmatrix -> geloescht
     // Mathematische Funktionen moeglich
};

template<class T>
ostream& operator<<(ostream& s, const Matrix<T>& m )
{
    typedef Matrix<T>::size_type size_type;
    for (size_type i = 0; i < m.Zeilen(); i++)
    { s << endl << i <<" :  ";
      for (size_type j = 0; j < m.Spalten(); j++)
           s << m[i][j] <<" ";
    }
    s <<endl;
    return s;
}
#endif






