#include "Detector.h"
#include <math.h>


double Detector::dist(Point a, double x, double y) {
  double dx, dy;
  dx = ( (double)a.x - x);
  dy = ( (double)a.y - y);
  return sqrt((dx*dx)+(dy*dy));  
};


double Detector::dist(Point a, Point b) {
  return dist(a, b.x, b.y);  
};


void Detector::setRectangle(const Rectangle tmpRect) {
  myRectangle = tmpRect;
};


Rectangle Detector::getRectangle() const {
  return myRectangle;
};


void Detector::setThreshold(const unsigned int tmpThreshold) {
  myThreshold = tmpThreshold;
};


unsigned int Detector::getThreshold() const {
  return myThreshold;
};


