#ifndef _FILTERBINARIZE_H_
#define _FILTERBINARIZE_H_


#include "FilterStrategy.h"


class FilterBinarize : public FilterStrategy {

public:

  FilterBinarize();
  ~FilterBinarize();

  Image* apply(const Image* source);

  FilterBinarize(unsigned int myThreshold);
  void setParameters(unsigned int myThreshold);
  void getParameters(unsigned int &myThreshold);

private:

  unsigned int myThreshold;

};

#endif // _FILTERBINARIZE_H_


