#ifndef _FILTERCUTRECTANGLE_H_
#define _FILTERCUTRECTANGLE_H_


#include "FilterStrategy.h"
#include "Rectangle.h"


class FilterCutRectangle : public FilterStrategy {

public:

  FilterCutRectangle();
  ~FilterCutRectangle();

  Image* apply(const Image* source);

  FilterCutRectangle(Rectangle);
  void setParameters(Rectangle);
  void getParameters(Rectangle&);


private:

  Rectangle myRect;

};

#endif // _FILTERCUTRECTANGLE_H_


