#ifndef _FILTEREXPANDGREYSCALE_H_
#define _FILTEREXPANDGREYSCALE_H_


#include "FilterStrategy.h"
#include "Rectangle.h"


class FilterExpandGreyscale : public FilterStrategy {

public:

  FilterExpandGreyscale();
  ~FilterExpandGreyscale();

  Image* apply(const Image* source);

  FilterExpandGreyscale(Rectangle bounds);
  void setParameters(Rectangle bounds);
  void getParameters(Rectangle &bounds);

private:
  
  Rectangle myBounds;

};

#endif // _FILTEREXPANDGREYSCALE_H_


