#include "FilterGreyscale.h"
#include "Image8.h"


FilterGreyscale::FilterGreyscale() { };


FilterGreyscale::~FilterGreyscale() { };


Image* FilterGreyscale::apply(const Image* source) {

  Image8* result = new Image8(source->getWidth(), source->getHeight());

  for(int y = 0; y < (int) source->getHeight(); y++) {
    for(int x = 0; x < (int) source->getWidth(); x++) {
      result->setGreyscale(x,y,source->getGreyscale(x,y));
    };
  };

  return result;

};


