#ifndef _FILTERSCALE_H_
#define _FILTERSCALE_H_


#include "FilterStrategy.h"


class FilterScale : public FilterStrategy {

public:

  FilterScale();
  ~FilterScale();

  Image* apply(const Image* source);

  FilterScale(float scale);
  void setParameters(float scale);
  void getParameters(float &scale);

private:

  float myScale;

};

#endif // _FILTERSCALE_H_


