#ifndef _NODE_H_
#define _NODE_H_


class Node {
  protected:
    Node *_next; // link to successor node
    Node *_prev; // link to predecessor node
  public:
    Node();
    virtual ~Node();
    Node *next();
    Node *prev();
    Node *insert(Node*);
    Node *remove();
    void splice(Node*);
};

#endif // _NODE_H_
